/** 
 * /file Windows Interface File for SWIG
 * /author Bernd Ottmann
 * /date   16.09.2014
 */

// ########################################################
// ############## ALLGEMEINE FUNKTIONEN ###################
// ########################################################

%{
#include "API.h"
%}

%include <Windows.i>

extern "C" __declspec(dllexport) int __stdcall DFCComOpenIV(int iComNum, int iBusNum, int iType, char *szComString, int iComValue, int iComTimeOut);
extern "C" __declspec(dllexport) void __stdcall DFCComClose(int iComNum);

extern "C" __declspec(dllexport) int __stdcall DFCIsChannelOpen(int channelID);

extern "C" __declspec(dllexport) int __stdcall DFCComSetTime(int iComNum, int iBusNum, unsigned char *pucDateTime);
extern "C" __declspec(dllexport) int __stdcall DFCComGetTime(int iComNum, int iBusNum, unsigned char *pucDateTime);

extern "C" __declspec(dllexport) int __stdcall DFCComSendMessage(int iComNum, int iBusNum, unsigned char ucDelayTime, unsigned char ucAction, unsigned char ucAudio, char *szMessage, int iLength);
extern "C" __declspec(dllexport) int __stdcall DFCComSendInfotext(int iComNum, int iBusNum, char *szMessage,int iLength);

extern "C" __declspec(dllexport) int __stdcall DFCGetSeriennummer(int iComNum, int iBusNum, int *piError, int *piSerialNum);


extern "C" __declspec(dllexport) int __stdcall DFCSystemReadRecord(int channelID, int deviceID, char *buf, int *length, int *error);
extern "C" __declspec(dllexport) int __stdcall DFCSystemQuitRecord(int channelID, int deviceID, int *error);
extern "C" __declspec(dllexport) int __stdcall DFCSystemRestoreRecords(int channelID, int deviceID, int *piError);

extern "C" __declspec(dllexport) void __stdcall DFCSetCallBack(int iComNum, int (*CBFunction)(void));

extern "C" __declspec(dllexport) void __stdcall DFCGetErrorText(int iComNum, int iError, int iLanguage, char *szText, int iLength);

extern "C" __declspec(dllexport) int __stdcall DFCSetGlobVar(int iComNum, int iBusNum, unsigned char *pucVar, int iType, unsigned char *pucValue, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCGetGlobVar(int iComNum, int iBusNum, unsigned char *pucVar, int iType, unsigned char *pucValue, int iValueLength, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCCloseRelay(int iComNum, int iBusNum, int iNum, int iTime, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCGetRelayState(int iComNum, int iBusNum, int iNum, int *piState, int *piTime, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCOpenRelay(int iComNum, int iBusNum, int iNum, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCWrite(int iComNum, char *pBuf, int iLength, int *piWriteLength, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCRead(int iComNum, char *pBuf, int iLength, int *piReadLength, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCUpload(int iComNum, int iBusNum, char *szFileName, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCGetVersionFirmware(int iComNum, int iBusNum, char *pVersion, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCGetVersionFirmwareFromFile(int iComNum, char *pFileName, char *pVersion, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCReadHardwareInfo(int channelID, int terminalID, char *infoString, int *infoStringLength, int flags, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCSetupLaden(int iComNum,int iBusNum, char *szFileName, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCDownload(int iComNum,int iBusNum, char *szFileName, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCComClearData(int iComNum, int iBusNum);

extern "C" __declspec(dllexport) int __stdcall DFCLoadDatensatzbeschreibung(int iComNum, int iBusNum, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCDatBCnt(int iComNum);
extern "C" __declspec(dllexport) int __stdcall DFCDatBDatensatz(int iComNum, int iDataNum, unsigned char *szName, int *piFieldCount);
extern "C" __declspec(dllexport) int __stdcall DFCDatBFeld(int iComNum, int iDataNum, int iField, unsigned char *szName, int *piType, int *piLength);

extern "C" __declspec(dllexport) int __stdcall DFCReadRecord(int channelID, int deviceID, char *buf, int *length, int *err);
extern "C" __declspec(dllexport) int __stdcall DFCQuitRecord(int channelID, int deviceID, int *err);

extern "C" __declspec(dllexport) int __stdcall DFCMakeListe(int iComNum, int iListNum, int iLineCount, int iListSize, unsigned char *pucBuf, int iListMemSizeNum);
extern "C" __declspec(dllexport) int __stdcall DFCLoadListen(int iComNum, int iBusNum, int *piError);
extern "C" __declspec(dllexport) void __stdcall DFCClrListenBuffer(int iComNum);

extern "C" __declspec(dllexport) int __stdcall DFCLoadListenbeschreibung(int iComNum, int iBusNum, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCListBCnt(int iComNum);
extern "C" __declspec(dllexport) int __stdcall DFCListBDatensatz(int iComNum, int iDataNum, unsigned char *szName, int *piFieldCount, int *piVar);
extern "C" __declspec(dllexport) int __stdcall DFCListBFeld(int iComNum, int iDataNum, int iField, unsigned char *szName, int *piType, int *piLength);

extern "C" __declspec(dllexport) int __stdcall DFCMakeEntrance2List(int iComNum, int iListNum, int iLineCount, int iListSize, unsigned char *pucBuf, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCLoadEntrance2List(int iComNum, int iBusNum, int iListNum, int *piError);
extern "C" __declspec(dllexport) void __stdcall DFCClearEntrance2ListBuffer(int iComNum, int iListNum);
extern "C" __declspec(dllexport) int __stdcall DFCEntrance2Identification(int channelID, int deviceID, char *TM, char *Id, char *Pin, char *status, int *len, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCEntrance2OnlineAction(int channelID, int deviceID, char *TM, int mask, int type, int duration, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCFingerprintAppendRecord(int channelID, int deviceID, int type, unsigned char *fingertemplate, int size, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCFingerprintGetRecord(int channelID, int deviceID, int type, int pid, int fid, unsigned char *fingertemplate,int *size, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCFingerprintDeleteRecord(int channelID, int deviceID, int pid, int fid, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCFingerprintList(int channelID, int deviceID, int flags, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCFingerprintBackup(int channelID, int deviceID, char *backupFile, int flags, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCFingerprintRestore(int channelID, int deviceID, char *backupFile, int flags, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCMakeTimeboyList(int iChannelNum, int iGroupID, int iListNum, int iLineCount, int iListSize, unsigned char *pucBuf, int flags, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCLoadTimeboyList(int iChannelNum, int iBusNum, int iGroupID, int iListNum, int reserve, int *piError);
extern "C" __declspec(dllexport) void __stdcall DFCClearTimeboyListBuffer(int iChannelNum, int iGroupID, int iListNum);

extern "C" __declspec(dllexport) int __stdcall DFCStartActiveConnection(char *ip, int port, int deviceID, int timeout, int aliveTO, int maxConnections, int infoFlags, int reserved, int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCStopActiveConnection(int *piError);
extern "C" __declspec(dllexport) int __stdcall DFCGetFirstActiveChannelID();
extern "C" __declspec(dllexport) int __stdcall DFCGetNextActiveChannelID(int prev);
extern "C" __declspec(dllexport) int __stdcall DFCGetInfoActiveChannel(int channelID, char *infoString, int *infoStringLength);
extern "C" __declspec(dllexport) int __stdcall DFCSetRecordAvailable(int enable);
extern "C" __declspec(dllexport) int __stdcall DFCRecordAvailable(int *channelID, int *deviceID, char *infoString, int *infoStringLength, int *error);
extern "C" __declspec(dllexport) int __stdcall DFCBindDeviceToChannel(int channelID, int deviceType, int deviceSerial, char *deviceIp, int *piError);

extern "C" __declspec(dllexport) int __stdcall DFCVersionLibrary( char *version, int length );
